osgGA::AnimationPathManipulator Class Reference

`#include <AnimationPathManipulator>`

Inheritance diagram for osgGA::AnimationPathManipulator:

## Classes

struct | AnimationCompletedCallback

## Public Member Functions

| AnimationPathManipulator (osg::AnimationPath *animationPath=0)
| AnimationPathManipulator (const std::string &filename)
virtual const char * | className () const
void | setTimeScale (double s)
double | getTimeScale () const
void | setTimeOffset (double o)
double | getTimeOffset () const
void | setAnimationCompletedCallback (AnimationCompletedCallback *acc)
AnimationCompletedCallback * | getAnimationCompletedCallback ()
const AnimationCompletedCallback * | getAnimationCompletedCallback () const
void | setPrintOutTimingInfo (bool printOutTimingInfo)
bool | getPrintOutTimingInfo () const
virtual void | setByMatrix (const osg::Matrixd &matrix)
virtual void | setByInverseMatrix (const osg::Matrixd &matrix)
virtual osg::Matrixd | getMatrix () const
virtual osg::Matrixd | getInverseMatrix () const
void | setAnimationPath (osg::AnimationPath *animationPath)
osg::AnimationPath * | getAnimationPath ()
const osg::AnimationPath * | getAnimationPath () const
bool | valid () const
void | init (const GUIEventAdapter &ea, GUIActionAdapter &us)
void | home (const GUIEventAdapter &ea, GUIActionAdapter &us)
void | home (double currentTime)
virtual bool | handle (const GUIEventAdapter &ea, GUIActionAdapter &us)
virtual void | getUsage (osg::ApplicationUsage &usage) const
Public Member Functions inherited from osgGA::CameraManipulator
virtual void | setCoordinateFrameCallback (CoordinateFrameCallback *cb)
CoordinateFrameCallback * | getCoordinateFrameCallback ()
const CoordinateFrameCallback * | getCoordinateFrameCallback () const
osg::CoordinateFrame | getCoordinateFrame (const osg::Vec3d &position) const
osg::Vec3d | getSideVector (const osg::CoordinateFrame &cf) const
osg::Vec3d | getFrontVector (const osg::CoordinateFrame &cf) const
osg::Vec3d | getUpVector (const osg::CoordinateFrame &cf) const
virtual void | updateCamera (osg::Camera &camera)
virtual osgUtil::SceneView::FusionDistanceMode | getFusionDistanceMode () const
virtual float | getFusionDistanceValue () const
void | setIntersectTraversalMask (unsigned int mask)
unsigned int | getIntersectTraversalMask () const
virtual void | setNode (osg::Node *)
virtual const osg::Node * | getNode () const
virtual osg::Node * | getNode ()
virtual void | setHomePosition (const osg::Vec3d &eye, const osg::Vec3d &center, const osg::Vec3d &up, bool autoComputeHomePosition=false)
virtual void | getHomePosition (osg::Vec3d &eye, osg::Vec3d &center, osg::Vec3d &up) const
virtual void | setAutoComputeHomePosition (bool flag)
bool | getAutoComputeHomePosition () const
virtual void | computeHomePosition (const osg::Camera *camera=NULL, bool useBoundingBox=false)
virtual void | finishAnimation ()
virtual bool | handle (osgGA::Event *event, osg::Object *object, osg::NodeVisitor *nv)
Public Member Functions inherited from osgGA::GUIEventHandler
| GUIEventHandler ()
| GUIEventHandler (const GUIEventHandler &eh, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osgGA, GUIEventHandler)
virtual bool | handle (const GUIEventAdapter &ea, GUIActionAdapter &aa, osg::Object *, osg::NodeVisitor *)
Public Member Functions inherited from osgGA::EventHandler
| EventHandler ()
| EventHandler (const EventHandler &eh, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osgGA, EventHandler)
virtual NodeCallback * | asNodeCallback ()
virtual const NodeCallback * | asNodeCallback () const
virtual DrawableEventCallback * | asDrawableEventCallback ()
virtual const DrawableEventCallback * | asDrawableEventCallback () const
virtual EventHandler * | asEventHandler ()
virtual const EventHandler * | asEventHandler () const
virtual bool | run (osg::Object *object, osg::Object *data)
virtual void | operator() (osg::Node *node, osg::NodeVisitor *nv)
virtual void | event (osg::NodeVisitor *nv, osg::Drawable *drawable)
Public Member Functions inherited from osg::NodeCallback
| NodeCallback ()
| NodeCallback (const NodeCallback &nc, const CopyOp &copyop)
| META_Object (osg, NodeCallback)
Public Member Functions inherited from osg::Callback
| Callback ()
| Callback (const Callback &cb, const CopyOp &copyop)
| META_Object (osg, Callback)
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual StateAttributeCallback * | asStateAttributeCallback ()
virtual const StateAttributeCallback * | asStateAttributeCallback () const
virtual UniformCallback * | asUniformCallback ()
virtual const UniformCallback * | asUniformCallback () const
virtual DrawableUpdateCallback * | asDrawableUpdateCallback ()
virtual const DrawableUpdateCallback * | asDrawableUpdateCallback () const
virtual DrawableCullCallback * | asDrawableCullCallback ()
virtual const DrawableCullCallback * | asDrawableCullCallback () const
bool | traverse (osg::Object *object, osg::Object *data)
void | setNestedCallback (osg::Callback *cb)
osg::Callback * | getNestedCallback ()
const osg::Callback * | getNestedCallback () const
void | addNestedCallback (osg::Callback *nc)
void | removeNestedCallback (osg::Callback *nc)
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *) const
virtual const char * | libraryName () const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const
Public Member Functions inherited from osg::DrawableEventCallback
| DrawableEventCallback ()
| DrawableEventCallback (const DrawableEventCallback &org, const CopyOp &copyop)
| META_Object (osg, DrawableEventCallback)

## Protected Member Functions

void | handleFrame (double time)
Protected Member Functions inherited from osgGA::CameraManipulator
| CameraManipulator ()
| CameraManipulator (const CameraManipulator &mm, const osg::CopyOp &copyOp=osg::CopyOp::SHALLOW_COPY)
virtual | ~CameraManipulator ()
std::string | getManipulatorName () const
Protected Member Functions inherited from osgGA::GUIEventHandler
virtual | ~GUIEventHandler ()
Protected Member Functions inherited from osg::NodeCallback
virtual | ~NodeCallback ()
Protected Member Functions inherited from osg::Callback
virtual | ~Callback ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

bool | _valid
bool | _printOutTimingInfo
osg::ref_ptr< osg::AnimationPath > | _animationPath
double | _timeOffset
double | _timeScale
osg::ref_ptr< AnimationCompletedCallback > | _animationCompletedCallback
double | _pauseTime
bool | _isPaused
double | _realStartOfTimedPeriod
double | _animStartOfTimedPeriod
int | _numOfFramesSinceStartOfTimedPeriod
osg::Matrixd | _matrix
Protected Attributes inherited from osgGA::CameraManipulator
unsigned int | _intersectTraversalMask
bool | _autoComputeHomePosition
osg::Vec3d | _homeEye
osg::Vec3d | _homeCenter
osg::Vec3d | _homeUp
osg::ref_ptr< CoordinateFrameCallback > | _coordinateFrameCallback
Protected Attributes inherited from osg::Callback
ref_ptr< Callback > | _nestedCallback
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Constructor & Destructor Documentation

## AnimationPathManipulator() [1/2]

osgGA::AnimationPathManipulator::AnimationPathManipulator | ( | osg::AnimationPath * | animationPath = 0 | ) |

Referenced by osgGA::AnimationPathManipulator::AnimationCompletedCallback::completed().

## AnimationPathManipulator() [2/2]

osgGA::AnimationPathManipulator::AnimationPathManipulator | ( | const std::string & | filename | ) |

## Member Function Documentation

## className()

virtual const char * osgGA::AnimationPathManipulator::className | ( |  | ) | const

inline virtual

return the name of the object's class type. Must be defined by derived classes.

Reimplemented from osgGA::CameraManipulator.

## getAnimationCompletedCallback() [1/2]

AnimationCompletedCallback * osgGA::AnimationPathManipulator::getAnimationCompletedCallback | ( |  | ) |

inline

References _animationCompletedCallback.

## getAnimationCompletedCallback() [2/2]

const AnimationCompletedCallback * osgGA::AnimationPathManipulator::getAnimationCompletedCallback | ( |  | ) | const

inline

References _animationCompletedCallback.

## getAnimationPath() [1/2]

osg::AnimationPath * osgGA::AnimationPathManipulator::getAnimationPath | ( |  | ) |

inline

References _animationPath.

## getAnimationPath() [2/2]

const osg::AnimationPath * osgGA::AnimationPathManipulator::getAnimationPath | ( |  | ) | const

inline

References _animationPath.

## getInverseMatrix()

virtual osg::Matrixd osgGA::AnimationPathManipulator::getInverseMatrix | ( |  | ) | const

inline virtual

get the position of the manipulator as a inverse matrix of the manipulator, typically used as a model view matrix.

Implements osgGA::CameraManipulator.

References _matrix, and osg::Matrixd::inverse().

## getMatrix()

virtual osg::Matrixd osgGA::AnimationPathManipulator::getMatrix | ( |  | ) | const

inline virtual

get the position of the manipulator as 4x4 Matrix.

Implements osgGA::CameraManipulator.

References _matrix.

## getPrintOutTimingInfo()

bool osgGA::AnimationPathManipulator::getPrintOutTimingInfo | ( |  | ) | const

inline

References _printOutTimingInfo.

## getTimeOffset()

double osgGA::AnimationPathManipulator::getTimeOffset | ( |  | ) | const

inline

References _timeOffset.

## getTimeScale()

double osgGA::AnimationPathManipulator::getTimeScale | ( |  | ) | const

inline

References _timeScale.

## getUsage()

virtual void osgGA::AnimationPathManipulator::getUsage | ( | osg::ApplicationUsage & | usage | ) | const

virtual

Get the keyboard and mouse usage of this manipulator.

Reimplemented from osgGA::EventHandler.

## handle()

virtual bool osgGA::AnimationPathManipulator::handle | ( | const GUIEventAdapter & | ea,
|  | GUIActionAdapter & | us )

virtual

Handle events, return true if handled, false otherwise.

Reimplemented from osgGA::CameraManipulator.

## handleFrame()

void osgGA::AnimationPathManipulator::handleFrame | ( | double | time | ) |

protected

## home() [1/2]

void osgGA::AnimationPathManipulator::home | ( | const GUIEventAdapter & | ,
|  | GUIActionAdapter & | )

virtual

Move the camera to the default position. May be ignored by manipulators if home functionality is not appropriate.

Reimplemented from osgGA::CameraManipulator.

## home() [2/2]

void osgGA::AnimationPathManipulator::home | ( | double |  | ) |

virtual

Move the camera to the default position. This version does not require GUIEventAdapter and GUIActionAdapter so may be called from somewhere other than a handle() method in GUIEventHandler. Application must be aware of implications.

Reimplemented from osgGA::CameraManipulator.

## init()

void osgGA::AnimationPathManipulator::init | ( | const GUIEventAdapter & | ,
|  | GUIActionAdapter & | )

virtual

Start/restart the manipulator.

Reimplemented from osgGA::CameraManipulator.

## setAnimationCompletedCallback()

void osgGA::AnimationPathManipulator::setAnimationCompletedCallback | ( | AnimationCompletedCallback * | acc | ) |

inline

References _animationCompletedCallback.

## setAnimationPath()

void osgGA::AnimationPathManipulator::setAnimationPath | ( | osg::AnimationPath * | animationPath | ) |

inline

References _animationPath.

## setByInverseMatrix()

virtual void osgGA::AnimationPathManipulator::setByInverseMatrix | ( | const osg::Matrixd & | matrix | ) |

inline virtual

set the position of the matrix manipulator using a 4x4 Matrix.

Implements osgGA::CameraManipulator.

References _matrix.

## setByMatrix()

virtual void osgGA::AnimationPathManipulator::setByMatrix | ( | const osg::Matrixd & | matrix | ) |

inline virtual

set the position of the matrix manipulator using a 4x4 Matrix.

Implements osgGA::CameraManipulator.

References _matrix.

## setPrintOutTimingInfo()

void osgGA::AnimationPathManipulator::setPrintOutTimingInfo | ( | bool | printOutTimingInfo | ) |

inline

References _printOutTimingInfo.

## setTimeOffset()

void osgGA::AnimationPathManipulator::setTimeOffset | ( | double | o | ) |

inline

References _timeOffset.

## setTimeScale()

void osgGA::AnimationPathManipulator::setTimeScale | ( | double | s | ) |

inline

References _timeScale.

## valid()

bool osgGA::AnimationPathManipulator::valid | ( |  | ) | const

inline

References _animationPath.

## Member Data Documentation

## _animationCompletedCallback

osg::ref_ptr<AnimationCompletedCallback> osgGA::AnimationPathManipulator::_animationCompletedCallback

protected

Referenced by getAnimationCompletedCallback(), getAnimationCompletedCallback(), and setAnimationCompletedCallback().

## _animationPath

osg::ref_ptr<osg::AnimationPath> osgGA::AnimationPathManipulator::_animationPath

protected

Referenced by getAnimationPath(), getAnimationPath(), setAnimationPath(), and valid().

## _animStartOfTimedPeriod

double osgGA::AnimationPathManipulator::_animStartOfTimedPeriod

protected

## _isPaused

bool osgGA::AnimationPathManipulator::_isPaused

protected

## _matrix

osg::Matrixd osgGA::AnimationPathManipulator::_matrix

protected

Referenced by getInverseMatrix(), getMatrix(), setByInverseMatrix(), and setByMatrix().

## _numOfFramesSinceStartOfTimedPeriod

int osgGA::AnimationPathManipulator::_numOfFramesSinceStartOfTimedPeriod

protected

## _pauseTime

double osgGA::AnimationPathManipulator::_pauseTime

protected

## _printOutTimingInfo

bool osgGA::AnimationPathManipulator::_printOutTimingInfo

protected

Referenced by getPrintOutTimingInfo(), and setPrintOutTimingInfo().

## _realStartOfTimedPeriod

double osgGA::AnimationPathManipulator::_realStartOfTimedPeriod

protected

## _timeOffset

double osgGA::AnimationPathManipulator::_timeOffset

protected

Referenced by getTimeOffset(), and setTimeOffset().

## _timeScale

double osgGA::AnimationPathManipulator::_timeScale

protected

Referenced by getTimeScale(), and setTimeScale().

## _valid

bool osgGA::AnimationPathManipulator::_valid

protected

The documentation for this class was generated from the following file:

- AnimationPathManipulator